diff -dur thread.original/locks.hpp thread/locks.hpp
--- thread.original/locks.hpp	Mon Jun 14 04:06:20 2010
+++ thread/locks.hpp	Mon Jun 14 04:29:10 2010
@@ -491,6 +491,12 @@
     {
         return static_cast<upgrade_lock<Mutex>&&>(ul);
     }
+
+    template<typename Mutex>
+    inline upgrade_lock<Mutex>&& move(upgrade_lock<Mutex>& ul)
+    {
+        return static_cast<upgrade_lock<Mutex>&&>(ul);
+    }
 #endif
     template<typename Mutex>
     void swap(unique_lock<Mutex>& lhs,unique_lock<Mutex>& rhs)
@@ -747,7 +753,7 @@
         {
             try_lock();
         }
-#ifdef BOOST_HAS_RVALUE_REFS
+#ifndef BOOST_NO_RVALUE_REFERENCES
         upgrade_lock(upgrade_lock<Mutex>&& other):
             m(other.m),is_locked(other.is_locked)
         {
@@ -775,7 +781,7 @@
 
         upgrade_lock& operator=(unique_lock<Mutex>&& other)
         {
-            upgrade_lock temp(other);
+            upgrade_lock temp(move(other));
             swap(temp);
             return *this;
         }
@@ -927,7 +933,7 @@
             }
         }
 
-#ifdef BOOST_HAS_RVALUE_REFS
+#ifndef BOOST_NO_RVALUE_REFERENCES
         upgrade_to_unique_lock(upgrade_to_unique_lock<Mutex>&& other):
             source(other.source),exclusive(move(other.exclusive))
         {
